## API Report File for "@genesislcap/foundation-fdc3"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { AppIntent } from '@finos/fdc3';
import { Channel } from '@finos/fdc3';
import { Context } from '@finos/fdc3';
import { ContextHandler } from '@finos/fdc3';
import { Controller } from '@microsoft/fast-element';
import { DOMContainer } from '@genesislcap/foundation-utils';
import { FoundationElement } from '@genesislcap/web-core';
import { FoundationElementRegistry } from '@microsoft/fast-foundation';
import { FoundationLayoutContainer } from '@genesislcap/foundation-utils';
import { IntentResolution } from '@finos/fdc3';
import { Intents } from '@finos/fdc3';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { IOConnectDesktop } from '@interopio/desktop';
import { LayoutCacheContainer } from '@genesislcap/foundation-utils';
import { NotificationDataRow } from '@genesislcap/foundation-notifications';
import { NotificationListener } from '@genesislcap/foundation-ui';
import { OverrideFoundationElementDefinition } from '@microsoft/fast-foundation';
import { ViewTemplate } from '@microsoft/fast-element';

// @alpha
export interface ChannelConfig {
    // (undocumented)
    callback: (any: any) => void;
    // (undocumented)
    channelName: string;
    // (undocumented)
    channelType: string;
}

// Warning: (ae-internal-missing-underscore) The name "DefaultFDC3" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class DefaultFDC3 implements FDC3 {
    constructor();
    // (undocumented)
    addChannelListener(channelName: string, channelType: string, callback: (any: any) => void): Promise<Channel>;
    // (undocumented)
    addIntentListeners(listeners: Map<FDC3Intents, FDC3ContextHandler>): void;
    // (undocumented)
    broadcastOnChannel(channelName: string, type: string, payload: any): Promise<void>;
    // (undocumented)
    broadcastOnChannelEventHandler(channelName: string, type: string): Promise<(e: any) => Promise<void>>;
    // (undocumented)
    findIntent(intent: FDC3Intents, context?: FDC3Context): Promise<FDC3AppIntent>;
    // (undocumented)
    findIntentsByContext(context: FDC3Context): Promise<FDC3AppIntent[]>;
    // (undocumented)
    getCurrentChannel(): Promise<Channel>;
    // (undocumented)
    getOrCreateChannel(channelId: string): Promise<FDC3Channel>;
    // (undocumented)
    isReady: boolean;
    // (undocumented)
    joinChannel(channelId: string): Promise<void>;
    // (undocumented)
    raiseIntent(context: FDC3Context, intent?: FDC3Intents): Promise<FDC3IntentResolution>;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FDC3" because one of its declarations is marked as @internal
//
// @public
export interface FDC3 {
    addChannelListener(channelName: string, channelType: string, callback: (any: any) => void): Promise<Channel>;
    addIntentListeners(listeners: Map<FDC3Intents, FDC3ContextHandler>): void;
    broadcastOnChannel(channelName: string, type: string, payload: any): Promise<void>;
    broadcastOnChannelEventHandler(channelName: string, type: string): Promise<(e: any) => Promise<void>>;
    findIntent(intent: FDC3Intents, context?: FDC3Context): Promise<FDC3AppIntent>;
    findIntentsByContext(context: FDC3Context): Promise<FDC3AppIntent[]>;
    getCurrentChannel(): Promise<Channel>;
    getOrCreateChannel(channelId: string): Promise<FDC3Channel>;
    isReady: boolean;
    joinChannel(channelId: string): Promise<void>;
    raiseIntent(context: FDC3Context, intent?: FDC3Intents): Promise<FDC3IntentResolution>;
}

// @internal
export const FDC3: InterfaceSymbol<FDC3>;

// @public (undocumented)
export interface FDC3AppIntent extends AppIntent {
}

// @public (undocumented)
export interface FDC3Channel extends Channel {
}

// Warning: (ae-forgotten-export) The symbol "Fdc3ChannelEvent_base" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "Fdc3ChannelEvent" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class Fdc3ChannelEvent extends Fdc3ChannelEvent_base {
    // (undocumented)
    channelName: string;
    // (undocumented)
    channelType: string;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    eventName: string;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    mappingFunction: (any: any) => any;
}

// @public (undocumented)
export interface FDC3Context extends Context {
}

// @public (undocumented)
export type FDC3ContextHandler = ContextHandler;

// @public (undocumented)
export interface FDC3IntentResolution extends IntentResolution {
}

// @public (undocumented)
export type FDC3Intents = Intents;

// Warning: (ae-forgotten-export) The symbol "Fdc3Listener_base" needs to be exported by the entry point index.d.ts
//
// @alpha
export class Fdc3Listener extends Fdc3Listener_base {
    // (undocumented)
    channelConfig: ChannelConfig[];
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    intentConfig: IntentConfig[];
}

// Warning: (ae-forgotten-export) The symbol "Fdc3RaiseIntent_base" needs to be exported by the entry point index.d.ts
//
// @alpha
export class Fdc3RaiseIntent extends Fdc3RaiseIntent_base {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    eventName: string;
    // (undocumented)
    fdc3: FDC3;
    // (undocumented)
    intentName: string;
    // (undocumented)
    intentType: string;
    // (undocumented)
    mappingFunction: (any: any) => any;
}

// @alpha
export interface IntentConfig {
    // (undocumented)
    callback: (any: any) => void;
    // (undocumented)
    intent: string;
}

// @public
export const interopFoundationNotificationListener: (overrideDefinition?: OverrideFoundationElementDefinition<    {
baseName: string;
template: ViewTemplate<NotificationListener, any>;
shadowOptions: ShadowRootInit;
}>) => FoundationElementRegistry<    {
baseName: string;
template: ViewTemplate<NotificationListener, any>;
shadowOptions: ShadowRootInit;
}, typeof InteropNotificationsListener>;

// @public (undocumented)
export class InteropNotificationsListener extends NotificationListener {
    // (undocumented)
    iOConnectNotificationOptions: IOConnectDesktop.Notifications.IOConnectNotificationOptions;
    // (undocumented)
    protected showNotificationToast(row: NotificationDataRow): void;
}

// (No @packageDocumentation comment for this package)

```
